<template>
  <div>
    <div class="row">
      <div class="col-xs-12">
        <p class="add-subscription-title">Выберите точки, по которым вас интересует перевозка</p>
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-select
          label="По точкам отгрузки"
          placeholder="Выберите одну или несколько точек"
          required
          :value="fromLocationsValue"
          :items="locations"
          :is-dropdown="true"
          :is-autoComplete="true"
          data-qa="fromLocations"
          display-exp="russianName"
          :class="{ isAll: isAll }"
          @input="input($event, 'from')"
        />
      </div>
    </div>
  </div>
</template>

<script>
  import ObSelect from 'common-components/src/obComponents/obSelect';
  import { mapGetters } from 'vuex';
  export default {
    name: 'SubscriptionModalLocationsPoints',
    components: {
      ObSelect
    },
    props: {
      fromLocations: {
        type: Object,
        required: true
      },
    },
    data(){
      return{
        locations: [],
        isAll: false
      }
    },
    mounted() {
      this.locations = this.listLocations.map(key => key)
      this.locations.unshift({ russianName: 'Все опорники', uuid: 'all' })
    },
    computed: {
      ...mapGetters({
        listLocations: 'subscriptions/listLocations'
      }),
      fromLocationsValue() {
        const locationUuids = this.locations.map(location => location.uuid)
        if (this.fromLocations.isAll) return locationUuids
        return this.fromLocations.fromLocationUuids
      }
    },
    methods: {
      input (event, direction) {
        const isAdd = this[`${direction}LocationsValue`].length < event.length
        const isAllSelected = isAdd && (event.includes('all') || event.length === this.listLocations.length)
        let locations = []

        if (isAllSelected) {
          locations = []
          this.isAll = true
        } else if (event.includes('all')) {
          locations = event.filter(locationUuid => locationUuid !== 'all')
          this.isAll = false
        } else {
          if (event.length === this.listLocations.length) {
            locations = []
          } else {
            locations = event
          }
          this.isAll = false
        }

        this.$emit('setLocations', locations, direction, this.isAll)
      },
    }
  };
</script>
<style lang="scss" scoped>
::v-deep {
  .isAll {
    .ob-selector__multi-select {
      &-item {
        &:first-child {
          display: none !important;
        }
      }
    }
  }
}
</style>